diff -urN Android_6.0.1_r11/frameworks/base/services/core/jni/Android.mk SAMD_6.0.1_r11_20170930/frameworks/base/services/core/jni/Android.mk
--- Android_6.0.1_r11/frameworks/base/services/core/jni/Android.mk	2017-09-27 02:07:57.551735999 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/jni/Android.mk	2016-11-01 17:36:40.414408000 +0900
@@ -33,6 +33,7 @@
     $(LOCAL_REL_DIR)/com_android_server_UsbHostManager.cpp \
     $(LOCAL_REL_DIR)/com_android_server_VibratorService.cpp \
     $(LOCAL_REL_DIR)/com_android_server_PersistentDataBlockService.cpp \
+    $(LOCAL_REL_DIR)/com_android_server_remote_RemoteService.cpp \
     $(LOCAL_REL_DIR)/onload.cpp
 
 LOCAL_C_INCLUDES += \
@@ -47,7 +48,7 @@
     system/security/keystore/include \
     $(call include-path-for, libhardware)/hardware \
     $(call include-path-for, libhardware_legacy)/hardware_legacy \
-
+    
 LOCAL_SHARED_LIBRARIES += \
     libandroid_runtime \
     libandroidfw \
@@ -71,4 +72,4 @@
     libEGL \
     libGLESv2 \
     libnetutils \
-
+    
diff -urN Android_6.0.1_r11/frameworks/base/services/core/jni/com_android_server_remote_RemoteService.cpp SAMD_6.0.1_r11_20170930/frameworks/base/services/core/jni/com_android_server_remote_RemoteService.cpp
--- Android_6.0.1_r11/frameworks/base/services/core/jni/com_android_server_remote_RemoteService.cpp	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/jni/com_android_server_remote_RemoteService.cpp	2016-11-01 17:36:40.414408000 +0900
@@ -0,0 +1,356 @@
+//#define LOG_TAG "RemoteService JNI"
+
+#include "jni.h"
+#include "JNIHelp.h"
+#include "android_os_MessageQueue.h"
+#include "android_runtime/AndroidRuntime.h"
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <stdint.h>
+
+#include <dirent.h>
+#include <cutils/fs.h>
+#include <sys/stat.h>
+
+#include <gui/Sensor.h>
+#include <gui/SensorManager.h>
+
+#define PKG_PATH_MAX	256
+
+namespace android
+{
+
+void mkinnerdirs(char* path, int basepos, mode_t mode, int uid, int gid,
+        struct stat* statbuf)
+{
+    while (path[basepos] != 0) {
+        if (path[basepos] == '/') {
+            path[basepos] = 0;
+            if (lstat(path, statbuf) < 0) {
+                ALOGV("Making directory: %s\n", path);
+                if (mkdir(path, mode) == 0) {
+                    chown(path, uid, gid);
+                } else {
+                    ALOGW("Unable to make directory %s: %s\n", path, strerror(errno));
+                }
+            }
+            path[basepos] = '/';
+            basepos++;
+        }
+        basepos++;
+    }
+}
+
+int movefileordir(char* srcpath, char* dstpath, int dstbasepos,
+        int dstuid, int dstgid, struct stat* statbuf)
+{
+    DIR *d;
+    struct dirent *de;
+    int res;
+
+    int srcend = strlen(srcpath);
+    int dstend = strlen(dstpath);
+
+    if (lstat(srcpath, statbuf) < 0) {
+        ALOGW("Unable to stat %s: %s\n", srcpath, strerror(errno));
+        return 1;
+    }
+
+    if ((statbuf->st_mode&S_IFDIR) == 0) {
+        mkinnerdirs(dstpath, dstbasepos, S_IRWXU|S_IRWXG|S_IXOTH,
+                dstuid, dstgid, statbuf);
+        ALOGV("Renaming %s to %s (uid %d)\n", srcpath, dstpath, dstuid);
+        if (rename(srcpath, dstpath) >= 0) {
+            if (chown(dstpath, dstuid, dstgid) < 0) {
+                ALOGE("cannot chown %s: %s\n", dstpath, strerror(errno));
+                unlink(dstpath);
+                return 1;
+            }
+        } else {
+            ALOGW("Unable to rename %s to %s: %s\n",
+                srcpath, dstpath, strerror(errno));
+            return 1;
+        }
+        return 0;
+    }
+
+    d = opendir(srcpath);
+    if (d == NULL) {
+        ALOGW("Unable to opendir %s: %s\n", srcpath, strerror(errno));
+        return 1;
+    }
+
+    res = 0;
+
+    while ((de = readdir(d))) {
+        const char *name = de->d_name;
+            /* always skip "." and ".." */
+        if (name[0] == '.') {
+            if (name[1] == 0) continue;
+            if ((name[1] == '.') && (name[2] == 0)) continue;
+        }
+
+        if ((srcend+strlen(name)) >= (PKG_PATH_MAX-2)) {
+            ALOGW("Source path too long; skipping: %s/%s\n", srcpath, name);
+            continue;
+        }
+
+        if ((dstend+strlen(name)) >= (PKG_PATH_MAX-2)) {
+            ALOGW("Destination path too long; skipping: %s/%s\n", dstpath, name);
+            continue;
+        }
+
+        srcpath[srcend] = dstpath[dstend] = '/';
+        strcpy(srcpath+srcend+1, name);
+        strcpy(dstpath+dstend+1, name);
+
+        if (movefileordir(srcpath, dstpath, dstbasepos, dstuid, dstgid, statbuf) != 0) {
+            res = 1;
+        }
+
+        // Note: we will be leaving empty directories behind in srcpath,
+        // but that is okay, the package manager will be erasing all of the
+        // data associated with .apks that disappear.
+
+        srcpath[srcend] = dstpath[dstend] = 0;
+    }
+
+    closedir(d);
+    return res;
+}
+
+static int _delete_dir_contents(DIR *d)
+{
+	int result;
+	struct dirent *de;
+	int dfd;
+
+	dfd = dirfd(d);
+
+	while((de = readdir(d)))
+	{
+		const char *name = de->d_name;
+
+		if(de->d_type == DT_DIR)
+		{
+			int subfd;
+			DIR *subdir;
+
+			if(name[0] == '.')
+			{
+				if(name[1] == 0) continue;
+				if((name[1] == '.') && (name[2] == 0)) continue;
+			}
+
+			subfd = openat(dfd, name, O_RDONLY | O_DIRECTORY);
+			if(subfd < 0)
+			{
+				ALOGE("ERROR1 - %s", name);
+				result = -1;
+				continue;
+			}
+			subdir = fdopendir(subfd);
+			if(subdir == NULL)
+			{
+				ALOGE("ERROR2 - %s", name);
+				close(subfd);
+				result = -1;
+				continue;
+			}
+			if(_delete_dir_contents(subdir))
+			{
+				result = -1;
+			}
+			closedir(subdir);
+			if(unlinkat(dfd, name, AT_REMOVEDIR) < 0)
+			{
+				ALOGE("ERROR4 - %s", name);
+				result = -1;
+			}
+		}
+		else
+		{
+			if(unlinkat(dfd, name, 0) < 0)
+			{
+				ALOGE("ERROR5 - %s: %s", name, strerror(errno));
+				result = -1;
+			}
+		}
+	}
+
+	return result;
+}
+
+static void replace_oat(JNIEnv *env, jobject clazz, jstring jPath)
+{
+	const char *name = NULL;
+	name = jPath ? env->GetStringUTFChars(jPath, NULL) : NULL;
+
+	ALOGD("PATH = %s", name);
+
+
+	int dstuid = -1, dstgid = -1;
+	struct stat s;
+
+	/*
+	char buf[PKG_PATH_MAX+1];
+	int bufp, bufe, bufi, readlen;
+
+
+	char srcpkg[PKG_PATH_MAX];
+	char dstpkg[PKG_PATH_MAX];*/
+
+	char srcapk[PKG_PATH_MAX];
+	char srcoat[PKG_PATH_MAX];
+	char dstapk[PKG_PATH_MAX];
+	char dstoat[PKG_PATH_MAX];
+
+	/*strcpy(srcpkg, dex_path);
+	strcpy(dstpkg, "/data/app/com.android.dcslab.testapplication-1/base.apk");*/
+
+	//strcpy(srcapk, "/data/local/tmp/");
+	//strcpy(srcapk, "/system/app/Dummy/");
+	strcpy(srcapk, name);
+	//strcat(srcapk, name);
+	strcat(srcapk, ".apk");
+
+
+	//strcpy(srcoat, "/data/local/tmp/");
+	//strcpy(srcoat, "/system/app/Dummy/");
+	strcpy(srcoat, name);
+	//strcat(srcoat, name);
+	strcat(srcoat, ".odex");
+
+
+	strcpy(dstapk, "/system/app/Dummy/Dummy.apk");
+	strcpy(dstoat, "/system/app/Dummy/oat/arm64/Dummy.odex");
+
+	ALOGD("srcapk = %s\nsrcoat = %s", srcapk, srcoat);
+
+
+	// delete .apk and .odex
+	DIR *d1 = opendir("/system/app/Dummy");
+	int dfd = dirfd(d1);
+
+	if(unlinkat(dfd, dstapk, 0) < 0)
+	{
+		ALOGE("ERROR - %s: %s", dstapk, strerror(errno));
+	}
+
+	DIR *d2 = opendir("/system/app/Dummy/oat/arm64");
+	dfd = dirfd(d2);
+
+	if(unlinkat(dfd, dstoat, 0) < 0)
+	{
+		ALOGE("ERROR - %s: %s", dstoat, strerror(errno));
+	}
+
+
+
+
+	if (rename(srcapk, dstapk) < 0)
+	{
+		 ALOGW("Unable to rename %s to %s: %s\n",
+				 srcapk, dstapk, strerror(errno));
+	}
+
+	if (rename(srcoat, dstoat) < 0)
+	{
+		 ALOGW("Unable to rename %s to %s: %s\n",
+				 srcoat, dstoat, strerror(errno));
+	}
+
+
+
+	/*if(lstat(dstapk, &s) == 0)
+	{
+		dstuid = s.st_uid;
+		dstgid = s.st_gid;
+	}
+
+	//chown(srcpkg, dstuid, dstgid);
+	if (chown(srcapk, dstuid, dstgid) < 0) {
+		ALOGE("cannot chown %s: %s\n", srcapk, strerror(errno));
+		//unlink(dstpath);
+	}*/
+
+	lstat(srcapk, &s);
+	movefileordir(srcapk, dstapk, 0, dstuid, dstgid, &s);
+
+
+	/*if(lstat(dstoat, &s) == 0)
+	{
+		dstuid = s.st_uid;
+		dstgid = s.st_gid;
+	}
+
+	if (chown(srcoat, dstuid, dstgid) < 0) {
+		ALOGE("cannot chown %s: %s\n", srcoat, strerror(errno));
+		//unlink(dstpath);
+	}*/
+
+	lstat(srcoat, &s);
+	movefileordir(srcoat, dstoat, 0, dstuid, dstgid, &s);
+
+//	if(rename(dex_path, "/system/app/Dummy/oat/arm64/Dummy.odex") < 0)
+	/*if(rename(dex_path, "/data/local/tmp/Dummy2.odex") < 0)
+	{
+		ALOGE("Couldn't move %s: %s", dex_path, strerror(errno));
+	}*/
+
+
+	//delete_dir_contents(dex_path, 0, NULL);
+
+	//unlink(dex_path);
+}
+
+
+
+static JNINativeMethod gRemoteServiceMethods[] = {
+  //  { "sendRemoteEvent", "(II[FIJI)V", (void*)sendRemoteEvent },
+  //  { "setServerOn", "(Z)V", (void*)setServerOn }
+		{ "replaceOAT", "(Ljava/lang/String;)V", (void*)replace_oat }
+};
+
+/*
+static JNINativeMethod gReceiverMethods[] = {
+    { "sendRemoteEvent", "(II[FIJI)V", (void*)sendRemoteEvent }
+};
+*/
+
+
+
+#define FIND_CLASS(var, className) \
+        var = env->FindClass(className); \
+        LOG_FATAL_IF(! var, "Unable to find class " className); \
+        var = jclass(env->NewGlobalRef(var));
+
+#define GET_METHOD_ID(var, clazz, methodName, methodDescriptor) \
+        var = env->GetMethodID(clazz, methodName, methodDescriptor); \
+        LOG_FATAL_IF(! var, "Unable to find method " methodName);
+
+int register_android_server_remote_RemoteService(JNIEnv *env)
+{
+	/*jniRegisterNativeMethods(env, "com/android/server/remote/RemoteService",
+			gRemoteServiceMethods, NELEM(gRemoteServiceMethods));*/
+/*
+	jniRegisterNativeMethods(env, "com/android/server/remote/Receiver",
+			gReceiverMethods, NELEM(gReceiverMethods));*/
+
+
+
+
+	/*FIND_CLASS(gBaseEventQueueClassInfo.clazz, "android/hardware/SystemSensorManager$BaseEventQueue");
+
+	GET_METHOD_ID(gBaseEventQueueClassInfo.dispatchSensorEvent,
+			gBaseEventQueueClassInfo.clazz,
+			"dispatchSensorEvent", "(I[FIJI)V");
+
+	GET_METHOD_ID(gBaseEventQueueClassInfo.dispatchFlushCompleteEvent,
+				  gBaseEventQueueClassInfo.clazz,
+				  "dispatchFlushCompleteEvent", "(I)V");*/
+
+	return 0;
+}
+};
diff -urN Android_6.0.1_r11/frameworks/base/services/core/jni/onload.cpp SAMD_6.0.1_r11_20170930/frameworks/base/services/core/jni/onload.cpp
--- Android_6.0.1_r11/frameworks/base/services/core/jni/onload.cpp	2017-09-27 02:07:57.555735999 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/jni/onload.cpp	2016-11-01 17:36:40.414408000 +0900
@@ -43,6 +43,7 @@
 int register_android_server_tv_TvInputHal(JNIEnv* env);
 int register_android_server_PersistentDataBlockService(JNIEnv* env);
 int register_android_server_Watchdog(JNIEnv* env);
+int register_android_server_remote_RemoteService(JNIEnv* env);
 };
 
 using namespace android;
@@ -81,6 +82,7 @@
     register_android_server_tv_TvInputHal(env);
     register_android_server_PersistentDataBlockService(env);
     register_android_server_Watchdog(env);
+    register_android_server_remote_RemoteService(env);
 
 
     return JNI_VERSION_1_4;
diff -urN Android_6.0.1_r11/frameworks/base/services/java/com/android/server/SystemServer.java SAMD_6.0.1_r11_20170930/frameworks/base/services/java/com/android/server/SystemServer.java
--- Android_6.0.1_r11/frameworks/base/services/java/com/android/server/SystemServer.java	2017-09-27 02:07:57.559735999 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/java/com/android/server/SystemServer.java	2017-09-15 13:05:48.784050000 +0900
@@ -56,8 +56,10 @@
 import com.android.server.camera.CameraService;
 import com.android.server.clipboard.ClipboardService;
 import com.android.server.content.ContentService;
+import com.android.server.devicemanagement.DeviceManagementService;
 import com.android.server.devicepolicy.DevicePolicyManagerService;
 import com.android.server.display.DisplayManagerService;
+import com.android.server.distribute.DistributedComputingService;
 import com.android.server.dreams.DreamManagerService;
 import com.android.server.fingerprint.FingerprintService;
 import com.android.server.hdmi.HdmiControlService;
@@ -79,6 +81,7 @@
 import com.android.server.power.PowerManagerService;
 import com.android.server.power.ShutdownThread;
 import com.android.server.restrictions.RestrictionsManagerService;
+import com.android.server.samd.SAMDService;
 import com.android.server.search.SearchManagerService;
 import com.android.server.statusbar.StatusBarManagerService;
 import com.android.server.storage.DeviceStorageMonitorService;
@@ -91,6 +94,9 @@
 import com.android.server.wallpaper.WallpaperManagerService;
 import com.android.server.webkit.WebViewUpdateService;
 import com.android.server.wm.WindowManagerService;
+import com.android.server.remote.RemoteService;
+import com.android.server.devicemanagement.DeviceManagementService;
+import com.android.server.distribute.DistributedComputingService;
 
 import dalvik.system.VMRuntime;
 
@@ -152,7 +158,9 @@
     private PackageManagerService mPackageManagerService;
     private PackageManager mPackageManager;
     private ContentResolver mContentResolver;
-
+    private RemoteService mRemoteService;
+    private SAMDService mSAMDService;
+    
     private boolean mOnlyCore;
     private boolean mFirstBoot;
 
@@ -360,6 +368,12 @@
             Slog.w(TAG, "Device encrypted - only parsing core apps");
             mOnlyCore = true;
         }
+        // ADDED FOR COLLABOROID
+        mRemoteService = new RemoteService(mSystemContext);
+        ServiceManager.addService(Context.REMOTE_SERVICE, mRemoteService);
+
+        mSAMDService = new SAMDService(mSystemContext);
+        ServiceManager.addService(Context.SAMD_SERVICE, mSAMDService);
 
         // Start the package manager.
         Slog.i(TAG, "Package Manager");
@@ -368,6 +382,8 @@
         mFirstBoot = mPackageManagerService.isFirstBoot();
         mPackageManager = mSystemContext.getPackageManager();
 
+
+
         Slog.i(TAG, "User Service");
         ServiceManager.addService(Context.USER_SERVICE, UserManagerService.getInstance());
 
@@ -380,6 +396,10 @@
         // The sensor service needs access to package manager service, app ops
         // service, and permissions service, therefore we start it after them.
         startSensorService();
+
+        //mSystemServiceManager.startService(RemoteService.class);
+        //mActivityManagerService.setSystemServiceManager(mSystemServiceManager);
+        //mRemoteService.setInstaller(installer);
     }
 
     /**
@@ -429,7 +449,12 @@
         MmsServiceBroker mmsService = null;
         EntropyMixer entropyMixer = null;
         CameraService cameraService = null;
-
+        
+        // ADDED FOR COLLABOROID
+        DeviceManagementService deviceService = null;
+        //RemoteService remoteService = null;
+        DistributedComputingService distributedComputingService = null;
+        
         boolean disableStorage = SystemProperties.getBoolean("config.disable_storage", false);
         boolean disableBluetooth = SystemProperties.getBoolean("config.disable_bluetooth", false);
         boolean disableLocation = SystemProperties.getBoolean("config.disable_location", false);
@@ -484,6 +509,24 @@
             Slog.i(TAG, "Consumer IR Service");
             consumerIr = new ConsumerIrService(context);
             ServiceManager.addService(Context.CONSUMER_IR_SERVICE, consumerIr);
+            
+            // ADDED FOR COLLABOROID
+            Slog.i(TAG, "Device Management Service");
+            deviceService = new DeviceManagementService(context);
+            ServiceManager.addService(Context.DEVICE_MANAGEMENT_SERVICE, deviceService);
+            
+            /*Slog.i(TAG, "Remote Service");
+            remoteService = new RemoteService(context);
+            ServiceManager.addService(Context.REMOTE_SERVICE, remoteService);*/
+            //mSystemServiceManager.startService(RemoteService.class);
+            
+            /*Slog.i(TAG, "Consumer IR Service");
+            consumerIr = new ConsumerIrService(context);
+            ServiceManager.addService(Context.DISTRI_SERVICE, consumerIr);*/
+           
+            
+           
+            
 
             mSystemServiceManager.startService(AlarmManagerService.class);
             alarm = IAlarmManager.Stub.asInterface(
@@ -545,7 +588,7 @@
 
         // Bring up services needed for UI.
         if (mFactoryTestMode != FactoryTest.FACTORY_TEST_LOW_LEVEL) {
-            try {
+        	try {
                 Slog.i(TAG, "Input Method Service");
                 imm = new InputMethodManagerService(context, wm);
                 ServiceManager.addService(Context.INPUT_METHOD_SERVICE, imm);
@@ -605,7 +648,7 @@
 
         if (mFactoryTestMode != FactoryTest.FACTORY_TEST_LOW_LEVEL) {
             if (!disableNonCoreServices) {
-                try {
+            	try {
                     Slog.i(TAG,  "LockSettingsService");
                     lockSettings = new LockSettingsService(context);
                     ServiceManager.addService("lock_settings", lockSettings);
@@ -1066,7 +1109,7 @@
         } catch (Throwable e) {
             reportWtf("making Display Manager Service ready", e);
         }
-
+        
         // These are needed to propagate to the runnable below.
         final NetworkManagementService networkManagementF = networkManagement;
         final NetworkStatsService networkStatsF = networkStats;
@@ -1145,7 +1188,7 @@
                     reportWtf("Notifying AudioService running", e);
                 }
                 Watchdog.getInstance().start();
-
+                
                 // It is now okay to let the various system services start their
                 // third party code...
                 mSystemServiceManager.startBootPhase(
diff -urN Android_6.0.1_r11/frameworks/base/tools/aapt/Android.mk SAMD_6.0.1_r11_20170930/frameworks/base/tools/aapt/Android.mk
--- Android_6.0.1_r11/frameworks/base/tools/aapt/Android.mk	2017-09-27 02:07:57.719735997 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/tools/aapt/Android.mk	2017-07-11 02:09:31.535236000 +0900
@@ -82,7 +82,8 @@
 ifneq ($(strip $(USE_MINGW)),)
     aaptHostStaticLibs += libz
 else
-    aaptHostLdLibs += -lz
+    #reviseApp
+    aaptHostLdLibs += -lz -llog
 endif
 
 
@@ -133,5 +134,30 @@
 
 include $(BUILD_HOST_NATIVE_TEST)
 
+# ==========================================================
+# Build the device executable: aapt
+# ==========================================================
+ifneq ($(SDK_ONLY),true)
+include $(CLEAR_VARS)
+
+LOCAL_MODULE := aapt
+LOCAL_CFLAGS += $(aaptCFlags)
+LOCAL_SRC_FILES := $(aaptSources) $(aaptMain)
+LOCAL_C_INCLUDES += \
+    $(aaptCIncludes) \
+    bionic
+LOCAL_SHARED_LIBRARIES := \
+    libandroidfw \
+    libutils \
+    libcutils \
+    libpng \
+    liblog \
+    libz
+LOCAL_STATIC_LIBRARIES := \
+    libexpat_static
+
+include $(BUILD_EXECUTABLE)
+
+endif # Not SDK_ONLY
 
 endif # No TARGET_BUILD_APPS or TARGET_BUILD_PDK
diff -urN Android_6.0.1_r11/frameworks/base/tools/aapt/ResourceTable.cpp SAMD_6.0.1_r11_20170930/frameworks/base/tools/aapt/ResourceTable.cpp
--- Android_6.0.1_r11/frameworks/base/tools/aapt/ResourceTable.cpp	2017-09-27 02:07:57.723735997 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/tools/aapt/ResourceTable.cpp	2017-07-12 02:48:38.326244000 +0900
@@ -17,9 +17,14 @@
 #include <utils/ByteOrder.h>
 #include <utils/TypeHelpers.h>
 #include <stdarg.h>
+// reviseApp
+#include <android/log.h>
 
 // SSIZE: mingw does not have signed size_t == ssize_t.
 // STATUST: mingw does seem to redefine UNKNOWN_ERROR from our enum value, so a cast is necessary.
+// reviseApp
+#define APPNAME "reviseApp"
+
 #if !defined(_WIN32)
 #  define SSIZE(x) x
 #  define STATUST(x) x
@@ -1864,6 +1869,15 @@
         .identifierForName(name.string(), name.size(),
                            type.string(), type.size(),
                            package.string(), package.size());
+    String8 s1(package);
+    String8 s2(type);
+    String8 s3(name);
+    String8 s4(value);
+    //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp package : %s" , s1.string());
+    //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp type : %s" , s2.string());
+    //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp name : %s" , s3.string());
+    //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp value : %s" , s4.string());
+
     if (rid != 0) {
         sourcePos.error("Resource entry %s/%s is already defined in package %s.",
                 String8(type).string(), String8(name).string(), String8(package).string());
@@ -3707,6 +3721,13 @@
         par.dataType = it.parsedValue.dataType;
         par.res0 = it.parsedValue.res0;
         par.data = htodl(it.parsedValue.data);
+
+
+        //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp item : %s" , String8(mName).string());
+        //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp par.data : 0x%x" , it.parsedValue.data);
+        //__android_log_print(ANDROID_LOG_VERBOSE, APPNAME, "reviseApp par.res0 : 0x%x" , par.res0);
+
+
         #if 0
         printf("Writing item (%s): type=%d, data=0x%x, res0=0x%x\n",
                String8(mName).string(), it.parsedValue.dataType,
diff -urN Android_6.0.1_r11/frameworks/base/tools/aapt2/SdkConstants.cpp SAMD_6.0.1_r11_20170930/frameworks/base/tools/aapt2/SdkConstants.cpp
--- Android_6.0.1_r11/frameworks/base/tools/aapt2/SdkConstants.cpp	2017-09-27 02:07:57.731735997 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/tools/aapt2/SdkConstants.cpp	2017-01-30 01:02:12.925758000 +0900
@@ -530,6 +530,8 @@
     { u"windowSwipeToDismiss", 20 },
     { u"isGame", 20 },
     { u"allowEmbedded", 20 },
+    //collaboroid
+    { u"remoteable", 20 },
     { u"setupActivity", 20 },
     { u"fastScrollStyle", 21 },
     { u"windowContentTransitions", 21 },
